﻿//
// Copyright(c) 2013,株式会社トラスト・ソフトウェア・システム
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Vwr
{
    public partial class Form2 : Form
    {
        private AxVIEWEROCXLib.AxPDFViewer vwr;

        public Form2(AxVIEWEROCXLib.AxPDFViewer v)
        {
            InitializeComponent();
            vwr = v;
        }

        //キャンセル
        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        //印刷
        private void btnOK_Click(object sender, EventArgs e)
        {
            //入力のチェック
            if (txtPrtName1.Text.Length < 1)
            {
                MessageBox.Show("第１のプリンター名を入力してください。");
                return;
            }
            if(txtPageFrom1.Text.Length < 1)
            {
                MessageBox.Show("第１の開始ページを入力してください。");
                return;
            }
            if (txtPageTo1.Text.Length < 1)
            {
                MessageBox.Show("第１の終了ページを入力してください。");
                return;
            }
            if (txtPrtName2.Text.Length < 1)
            {
                MessageBox.Show("第２のプリンター名を入力してください。");
                return;
            }
            if(txtPageFrom2.Text.Length < 1)
            {
                MessageBox.Show("第２の開始ページを入力してください。");
                return;
            }
            if (txtPageTo2.Text.Length < 1)
            {
                MessageBox.Show("第２の終了ページを入力してください。");
                return;
            }

            //第１ジョブ
            int p, f;
            int c = vwr.PageCount;
            if (!int.TryParse(txtPageFrom1.Text, out p))
            {
                MessageBox.Show("第１の開始ページには数値を入力してください。");
                return;
            }
            if (!int.TryParse(txtPageTo1.Text, out f))
            {
                MessageBox.Show("第１の終了ページには数値を入力してください。");
                return;
            }
            if (p < 1)
            {
                MessageBox.Show("第１の開始ページには1以上を入力してください。");
                return;
            }
            if (p > c)
            {
                MessageBox.Show(string.Format("第１の開始ページには{0}以下を入力してください。", c));
                return;
            }
            if (f < p)
            {
                MessageBox.Show(string.Format("第１の終了ページには{0}以上を入力してください。", p));
                return;
            }
            if (f > c)
            {
                MessageBox.Show(string.Format("第１の終了ページには{0}以下を入力してください。", c));
                return;
            }

            //第２ジョブ
            if (!int.TryParse(txtPageFrom2.Text, out p))
            {
                MessageBox.Show("第１の開始ページには数値を入力してください。");
                return;
            }
            if (!int.TryParse(txtPageTo2.Text, out f))
            {
                MessageBox.Show("第１の終了ページには数値を入力してください。");
                return;
            }
            if (p < 1)
            {
                MessageBox.Show("第１の開始ページには1以上を入力してください。");
                return;
            }
            if (p > c)
            {
                MessageBox.Show(string.Format("第１の開始ページには{0}以下を入力してください。", c));
                return;
            }
            if (f < p)
            {
                MessageBox.Show(string.Format("第１の終了ページには{0}以上を入力してください。", p));
                return;
            }
            if (f > c)
            {
                MessageBox.Show(string.Format("第１の終了ページには{0}以下を入力してください。", c));
                return;
            }

            //印刷開始
            //第１ジョブ
            if (!vwr.OpenPrinter(txtPrtName1.Text))
            {
                MessageBox.Show("第１のプリンターが不正です");
                return;
            }
            if (!vwr.BeginDocument("The first job."))
            {
                MessageBox.Show("第１のプリンターを開始できませんでした");
                return;
            }
            f = int.Parse(txtPageFrom1.Text);
            p = int.Parse(txtPageTo1.Text);
            for (int i = f; i <= p; i++)
            {
                if (!vwr.PrintPage(i))
                {
                    MessageBox.Show("第１のページ印刷に失敗しました");
                    vwr.EndDocument();
                    vwr.ClosePrinter();
                    return;
                }
            }
            vwr.EndDocument();
            vwr.ClosePrinter();

            //第２ジョブ
            if (!vwr.OpenPrinter(txtPrtName2.Text))
            {
                MessageBox.Show("第２のプリンターが不正です");
                return;
            }
            if (!vwr.BeginDocument("The first job."))
            {
                MessageBox.Show("第２のプリンターを開始できませんでした");
                return;
            }
            f = int.Parse(txtPageFrom2.Text);
            p = int.Parse(txtPageTo2.Text);
            for (int i = f; i <= p; i++)
            {
                if (!vwr.PrintPage(i))
                {
                    MessageBox.Show("第２のページ印刷に失敗しました");
                    vwr.EndDocument();
                    vwr.ClosePrinter();
                    return;
                }
            }
            vwr.EndDocument();
            vwr.ClosePrinter();

            this.Close();
        }
    }
}
